package xyz.twovb.sgm.games;

/*
 * Created by 2vb - 4/6/2024
 */

import org.apache.commons.io.FileUtils;
import org.bukkit.Bukkit;
import org.bukkit.NamespacedKey;
import org.bukkit.World;
import org.bukkit.WorldCreator;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import xyz.twovb.sgm.SGM;
import xyz.twovb.sgm.levels.LevelManager;
import xyz.twovb.toolbox.api.CustomPlayer;

import java.io.File;
import java.io.IOException;
import java.util.List;
import java.util.UUID;

public interface Minigame extends Listener {

    void init(CommandSender owner, String world) throws IOException;

    void start();

    void stop();

    void addPlayer(Player player);

    void removePlayer(Player player);

    List<Player> getPlayers();

    void onTick();

    String getName();

    UUID getGameId();

    GameState getState();

    CommandSender getOwner();

    default void sendMessageToAllPlayers(String message) {
        for (Player player : getPlayers()) {
            CustomPlayer cPlayer = new CustomPlayer(player);
            cPlayer.sendMessage(message);
        }
    }

    default World createGameWorld(String name, UUID id) throws IOException {
        File levelDir = new File(LevelManager.path + name);
//        if (Bukkit.getWorld(new NamespacedKey(SGM.getInstance(), "level_" + name)) != null) {
//            World levelWorld = Bukkit.getWorld(new NamespacedKey(SGM.getInstance(), "level_" + name));
//            if (levelWorld != null && levelWorld.getPlayerCount() == 0 && !Bukkit.isTickingWorlds()) {
//                Bukkit.getServer().unloadWorld(levelWorld, true);
//            } else {
//                return null;
//            }
//        }
        String tempName = name + "_" + id;
        File tempDir = new File(LevelManager.gamePath + tempName);
        FileUtils.copyDirectory(levelDir, tempDir);
        WorldCreator wc = new WorldCreator(LevelManager.gamePath + name, new NamespacedKey(SGM.getInstance(), name + "-" + UUID.randomUUID()));
        World world = wc.createWorld();
        if (world == null) return null;
        world.setAutoSave(false);
        return world;
    }

    enum GameState {
        PRESTART, READY, STARTED, ENDING
    }

}
